diff --git a/web/pgadmin/static/js/components/ExternalIcon.jsx b/web/pgadmin/static/js/components/ExternalIcon.jsx
new file mode 100644
index 000000000..b73a0ecb5
--- /dev/null
+++ b/web/pgadmin/static/js/components/ExternalIcon.jsx
@@ -0,0 +1,34 @@
+import React from 'react';
+import QueryToolSvg from '../../img/fonticon/query_tool.svg?svgr';
+import SaveDataSvg from '../../img/fonticon/save_data_changes.svg?svgr';
+import PasteSvg from '../../img/content_paste.svg?svgr';
+import FilterSvg from '../../img/filter_alt_black.svg?svgr';
+import ClearSvg from '../../img/cleaning_services_black.svg?svgr';
+import CommitSvg from '../../img/fonticon/commit.svg?svgr';
+import RollbackSvg from '../../img/fonticon/rollback.svg?svgr';
+import ConnectedSvg from '../../img/fonticon/connected.svg?svgr';
+import DisconnectedSvg from '../../img/fonticon/disconnected.svg?svgr';
+import RegexSvg from '../../img/fonticon/regex.svg?svgr';
+import FormatCaseSvg from '../../img/fonticon/format_case.svg?svgr';
+import PropTypes from 'prop-types';
+
+export default function ExternalIcon({Icon, ...props}) {
+  return <Icon className='MuiSvgIcon-root' {...props} />;
+}
+
+ExternalIcon.propTypes = {
+  Icon: PropTypes.elementType.isRequired,
+};
+
+export const QueryToolIcon = ()=><ExternalIcon Icon={QueryToolSvg} style={{height: '0.7em'}} />;
+export const SaveDataIcon = ()=><ExternalIcon Icon={SaveDataSvg} style={{height: '0.7em'}} />;
+export const PasteIcon = ()=><ExternalIcon Icon={PasteSvg} />;
+export const FilterIcon = ()=><ExternalIcon Icon={FilterSvg} />;
+export const CommitIcon = ()=><ExternalIcon Icon={CommitSvg} />;
+export const RollbackIcon = ()=><ExternalIcon Icon={RollbackSvg} />;
+export const ClearIcon = ()=><ExternalIcon Icon={ClearSvg} />;
+export const ConnectedIcon = ()=><ExternalIcon Icon={ConnectedSvg} style={{height: '0.7em'}} />;
+export const DisonnectedIcon = ()=><ExternalIcon Icon={DisconnectedSvg} style={{height: '0.7em'}} />;
+export const RegexIcon = ()=><ExternalIcon Icon={RegexSvg} />;
+export const FormatCaseIcon = ()=><ExternalIcon Icon={FormatCaseSvg} />;
+
diff --git a/web/pgadmin/static/js/components/FormComponents.jsx b/web/pgadmin/static/js/components/FormComponents.jsx
index 4deea23f4..e9edfd03d 100644
--- a/web/pgadmin/static/js/components/FormComponents.jsx
+++ b/web/pgadmin/static/js/components/FormComponents.jsx
@@ -11,7 +11,7 @@
 import React, { forwardRef, useCallback, useEffect, useRef, useState } from 'react';
 import { makeStyles } from '@material-ui/core/styles';
 import { Box, FormControl, OutlinedInput, FormHelperText,
-  Grid, IconButton, FormControlLabel, Switch, Checkbox, useTheme, InputLabel, Paper } from '@material-ui/core';
+  Grid, IconButton, FormControlLabel, Switch, Checkbox, useTheme, InputLabel, Paper, Select as MuiSelect } from '@material-ui/core';
 import { ToggleButton, ToggleButtonGroup } from '@material-ui/lab';
 import ErrorRoundedIcon from '@material-ui/icons/ErrorOutlineRounded';
 import InfoRoundedIcon from '@material-ui/icons/InfoRounded';
@@ -148,7 +148,7 @@ FormInput.propTypes = {
   testcid: PropTypes.any,
 };
 
-export function InputSQL({value, options, onChange, className, ...props}) {
+export function InputSQL({value, onChange, className, controlProps, ...props}) {
   const classes = useStyles();
   const editor = useRef();
 
@@ -156,17 +156,13 @@ export function InputSQL({value, options, onChange, className, ...props}) {
     <CodeMirror
       currEditor={(obj)=>editor.current=obj}
       value={value||''}
-      options={{
-        lineNumbers: true,
-        mode: 'text/x-pgsql',
-        ...options,
-      }}
       className={clsx(classes.sql, className)}
       events={{
         change: (cm)=>{
           onChange && onChange(cm.getValue());
         },
       }}
+      {...controlProps}
       {...props}
     />
   );
@@ -177,15 +173,16 @@ InputSQL.propTypes = {
   onChange: PropTypes.func,
   readonly: PropTypes.bool,
   className: CustomPropTypes.className,
+  controlProps: PropTypes.object,
 };
 
-export function FormInputSQL({hasError, required, label, className, helpMessage, testcid, value, controlProps, noLabel, ...props}) {
+export function FormInputSQL({hasError, required, label, className, helpMessage, testcid, value, noLabel, ...props}) {
   if(noLabel) {
-    return <InputSQL value={value} options={controlProps} {...props}/>;
+    return <InputSQL value={value} {...props}/>;
   } else {
     return (
       <FormInput required={required} label={label} error={hasError} className={className} helpMessage={helpMessage} testcid={testcid} >
-        <InputSQL value={value} options={controlProps} {...props}/>
+        <InputSQL value={value} {...props}/>
       </FormInput>
     );
   }
@@ -198,7 +195,6 @@ FormInputSQL.propTypes = {
   helpMessage: PropTypes.string,
   testcid: PropTypes.string,
   value: PropTypes.string,
-  controlProps: PropTypes.object,
   noLabel: PropTypes.bool,
   change: PropTypes.func,
 };
@@ -739,6 +735,17 @@ function getRealValue(options, value, creatable, formatter) {
   }
   return realValue;
 }
+export function InputSelectNonSearch({options, ...props}) {
+  return <MuiSelect native {...props} variant="outlined">
+    {(options||[]).map((o)=><option key={o.value} value={o.value}>{o.label}</option>)}
+  </MuiSelect>;
+}
+InputSelectNonSearch.propTypes = {
+  options: PropTypes.arrayOf(PropTypes.shape({
+    label: PropTypes.shape,
+    value: PropTypes.any,
+  })),
+};
 
 export const InputSelect = forwardRef(({
   cid, onChange, options, readonly=false, value, controlProps={}, optionsLoaded, optionsReloadBasis, disabled, ...props}, ref) => {
diff --git a/web/pgadmin/static/js/components/JsonEditor.jsx b/web/pgadmin/static/js/components/JsonEditor.jsx
new file mode 100644
index 000000000..ef7b910d7
--- /dev/null
+++ b/web/pgadmin/static/js/components/JsonEditor.jsx
@@ -0,0 +1,60 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import React, { useEffect, useMemo, useRef } from 'react';
+import {default as OrigJsonEditor} from 'jsoneditor.min';
+import PropTypes from 'prop-types';
+import CustomPropTypes from '../custom_prop_types';
+
+/* React wrapper for JsonEditor */
+export default function JsonEditor({currEditor, value, options, className}) {
+  const eleRef = useRef();
+  const editor = useRef();
+  const defaultOptions = {
+    modes: ['code', 'form', 'tree','preview'],
+  };
+
+  useEffect(()=>{
+    /* Create the object only once on mount */
+    editor.current = new OrigJsonEditor(eleRef.current, {
+      ...defaultOptions,
+      ...options,
+      onChange: ()=>{
+        let currVal = editor.current.getText();
+        if(currVal == '') {
+          currVal = null;
+        }
+        options.onChange(currVal);
+      }
+    });
+    editor.current.setText(value);
+    currEditor && currEditor(editor.current);
+    editor.current.focus();
+    return ()=>editor.current?.destroy();
+  }, []);
+
+  useMemo(() => {
+    if(editor.current) {
+      if(value != editor.current.getText()) {
+        editor.current.setText(value ?? '');
+      }
+    }
+  }, [value]);
+
+  return (
+    <div ref={eleRef} className={className}></div>
+  );
+}
+
+JsonEditor.propTypes = {
+  currEditor: PropTypes.func,
+  value: PropTypes.string,
+  options: PropTypes.object,
+  className: CustomPropTypes.className,
+};
diff --git a/web/pgadmin/static/js/components/Loader.jsx b/web/pgadmin/static/js/components/Loader.jsx
index bfdb8be5f..edb384e92 100644
--- a/web/pgadmin/static/js/components/Loader.jsx
+++ b/web/pgadmin/static/js/components/Loader.jsx
@@ -40,13 +40,13 @@ const useStyles = makeStyles((theme)=>({
   }
 }));
 
-export default function Loader({message}) {
+export default function Loader({message, style}) {
   const classes = useStyles();
   if(!message) {
     return <></>;
   }
   return (
-    <Box className={classes.root}>
+    <Box className={classes.root} style={style}>
       <Box className={classes.loaderRoot}>
         <CircularProgress className={classes.loader} />
         <Typography className={classes.message}>{message}</Typography>
@@ -57,4 +57,5 @@ export default function Loader({message}) {
 
 Loader.propTypes = {
   message: PropTypes.string,
+  style: PropTypes.oneOfType([PropTypes.object, PropTypes.array]),
 };
diff --git a/web/pgadmin/static/js/components/Menu.jsx b/web/pgadmin/static/js/components/Menu.jsx
new file mode 100644
index 000000000..2920d678d
--- /dev/null
+++ b/web/pgadmin/static/js/components/Menu.jsx
@@ -0,0 +1,83 @@
+import { makeStyles } from '@material-ui/styles';
+import React from 'react';
+import CheckIcon from '@material-ui/icons/Check';
+import PropTypes from 'prop-types';
+
+import {
+  MenuItem,
+  ControlledMenu,
+  applyStatics,
+} from '@szhsin/react-menu';
+export {MenuDivider as PgMenuDivider} from '@szhsin/react-menu';
+import { shortcutToString } from './ShortcutTitle';
+import clsx from 'clsx';
+import CustomPropTypes from '../custom_prop_types';
+
+const useStyles = makeStyles((theme)=>({
+  menu: {
+    '& .szh-menu': {
+      padding: '4px 0px',
+      zIndex: 1000,
+    },
+    '& .szh-menu__divider': {
+      margin: 0,
+    }
+  },
+  menuItem: {
+    display: 'flex',
+    padding: '4px 8px',
+    '&.szh-menu__item--active, &.szh-menu__item--hover': {
+      backgroundColor: theme.palette.primary.main,
+      color: theme.palette.primary.contrastText,
+    }
+  },
+  hideCheck: {
+    visibility: 'hidden',
+  },
+  shortcut: {
+    marginLeft: 'auto',
+    fontSize: '0.8em',
+    paddingLeft: '12px',
+  }
+}));
+
+export function PgMenu({open, className, ...props}) {
+  const classes = useStyles();
+  return (
+    <ControlledMenu
+      state={open ? 'open' : 'closed'}
+      {...props}
+      className={clsx(classes.menu, className)}
+    />
+  );
+}
+
+PgMenu.propTypes = {
+  open: PropTypes.bool,
+  className: CustomPropTypes.className,
+};
+
+export const PgMenuItem = applyStatics(MenuItem)(({hasCheck=false, checked=false, accesskey, shortcut, children, ...props})=>{
+  const classes = useStyles();
+  let onClick = props.onClick;
+  if(hasCheck) {
+    onClick = (e)=>{
+      e.keepOpen = true;
+      props.onClick(e);
+    };
+  }
+  return <MenuItem {...props} onClick={onClick} className={classes.menuItem}>
+    {hasCheck && <CheckIcon style={checked ? {} : {visibility: 'hidden'}}/>}
+    {children}
+    {(shortcut || accesskey) && <div className={classes.shortcut}>({shortcutToString(shortcut, accesskey)})</div>}
+  </MenuItem>;
+});
+
+PgMenuItem.propTypes = {
+  hasCheck: PropTypes.bool,
+  checked: PropTypes.bool,
+  accesskey: PropTypes.string,
+  shortcut: CustomPropTypes.shortcut,
+  children: CustomPropTypes.children,
+  onClick: PropTypes.func,
+};
diff --git a/web/pgadmin/static/js/components/ShortcutTitle.jsx b/web/pgadmin/static/js/components/ShortcutTitle.jsx
new file mode 100644
index 000000000..6ef1a564e
--- /dev/null
+++ b/web/pgadmin/static/js/components/ShortcutTitle.jsx
@@ -0,0 +1,63 @@
+import React from 'react';
+import { makeStyles } from '@material-ui/styles';
+import PropTypes from 'prop-types';
+import { isMac } from '../keyboard_shortcuts';
+import _ from 'lodash';
+import CustomPropTypes from '../custom_prop_types';
+
+const useStyles = makeStyles((theme)=>({
+  shortcut: {
+    justifyContent: 'center',
+    marginTop: '0.125rem',
+    display: 'flex',
+  },
+  key: {
+    padding: '0 0.25rem',
+    border: `1px solid ${theme.otherVars.borderColor}`,
+    marginRight: '0.125rem',
+    borderRadius: theme.shape.borderRadius,
+  },
+}));
+
+export function shortcutToString(shortcut, accesskey=null, asArray=false) {
+  let keys = [];
+  if(accesskey) {
+    keys.push('Accesskey');
+    keys.push(_.capitalize(accesskey?.toUpperCase()));
+  } else if(shortcut) {
+    shortcut.alt && keys.push((isMac() ? 'Option' : 'Alt'));
+    if(isMac() && shortcut.ctrl_is_meta) {
+      shortcut.control && keys.push('Cmd');
+    } else {
+      shortcut.control && keys.push('Ctrl');
+    }
+    shortcut.shift && keys.push('Shift');
+    keys.push(_.capitalize(shortcut.key.char));
+  } else {
+    return '';
+  }
+
+  return asArray ? keys : keys.join(' + ');
+}
+
+/* The tooltip content to show shortcut details */
+export default function ShortcutTitle({title, shortcut, accessKey}) {
+  const classes = useStyles();
+  let keys = shortcutToString(shortcut, accessKey, true);
+  return (
+    <>
+      <div>{title}</div>
+      <div className={classes.shortcut}>
+        {keys.map((key, i)=>{
+          return <div key={i} className={classes.key}>{key}</div>;
+        })}
+      </div>
+    </>
+  );
+}
+
+ShortcutTitle.propTypes = {
+  title: PropTypes.string,
+  shortcut: CustomPropTypes.shortcut,
+  accessKey: PropTypes.string,
+};
diff --git a/web/pgadmin/static/js/components/TabPanel.jsx b/web/pgadmin/static/js/components/TabPanel.jsx
index 6625fa028..406eba41c 100644
--- a/web/pgadmin/static/js/components/TabPanel.jsx
+++ b/web/pgadmin/static/js/components/TabPanel.jsx
@@ -13,12 +13,9 @@ import clsx from 'clsx';
 import PropTypes from 'prop-types';
 import CustomPropTypes from '../custom_prop_types';
 
-const useStyles = makeStyles((theme)=>({
+export const tabPanelStyles = makeStyles((theme)=>({
   root: {
-    height: '100%',
-    padding: theme.spacing(1),
-    overflow: 'auto',
-    backgroundColor: theme.palette.grey[400]
+    ...theme.mixins.tabPanel,
   },
   content: {
     height: '100%',
@@ -27,7 +24,7 @@ const useStyles = makeStyles((theme)=>({
 
 /* Material UI does not have any tabpanel component, we create one for us */
 export default function TabPanel({children, classNameRoot, className, value, index}) {
-  const classes = useStyles();
+  const classes = tabPanelStyles();
   const active = value === index;
   return (
     <Box className={clsx(classes.root, classNameRoot)} component="div" hidden={!active}>
diff --git a/web/pgadmin/static/js/custom_hooks.js b/web/pgadmin/static/js/custom_hooks.js
index ac9cf91f3..b6370bbbe 100644
--- a/web/pgadmin/static/js/custom_hooks.js
+++ b/web/pgadmin/static/js/custom_hooks.js
@@ -1,12 +1,10 @@
 import {useRef, useEffect, useState, useCallback} from 'react';
+export { useStopwatch } from 'react-timer-hook';
 
 /* React hook for setInterval */
 export function useInterval(callback, delay) {
   const savedCallback = useRef();
-
-  useEffect(() => {
-    savedCallback.current = callback;
-  });
+  savedCallback.current = callback;
 
   useEffect(() => {
     function tick() {
@@ -20,6 +18,19 @@ export function useInterval(callback, delay) {
   }, [delay]);
 }
 
+export function useDelayedCaller(callback) {
+  let timer;
+  useEffect(() => {
+    return () => clearTimeout(timer);
+  }, []);
+
+  return (delay)=>{
+    timer = setTimeout(() => {
+      callback();
+    }, delay);
+  };
+}
+
 export function usePrevious(value) {
   const ref = useRef();
   useEffect(() => {
@@ -66,3 +77,59 @@ export function useIsMounted() {
   }, []);
   return useCallback(() => ref.current, []);
 }
+
+
+/*
+  shortcuts = [
+    {
+      // From the preferences
+      shortcut: {
+        'control': true,
+        'shift': false,
+        'alt': true,
+        'key': {
+          'key_code': 73,
+          'char': 'I',
+        },
+      },
+      options: {
+        callback: ()=>{}
+        enabled?: boolean optional
+      }
+    }
+  ]
+*/
+export function useKeyboardShortcuts(shortcuts, eleRef) {
+  const shortcutsRef = useRef(shortcuts);
+
+  const matchFound = (shortcut, e)=>{
+    if(!shortcut) return false;
+    let keyCode = e.which || e.keyCode;
+    return shortcut.alt == e.altKey &&
+      shortcut.shift == e.shiftKey &&
+      shortcut.control == e.ctrlKey &&
+      shortcut.key.key_code == keyCode;
+  };
+  useEffect(()=>{
+    let ele = eleRef.current ?? document;
+    const keyupCallback = (e)=>{
+      for(let i=0; i<(shortcutsRef.current??[]).length; i++){
+        let {shortcut, options} = shortcutsRef.current[i];
+        if(matchFound(shortcut, e)) {
+          if(options.callback && (options.enabled ?? true)) {
+            options.callback(e);
+          }
+          break;
+        }
+      }
+    };
+    ele.addEventListener('keyup', keyupCallback);
+    return ()=>{
+      ele.removeEventListener('keyup', keyupCallback);
+    };
+  }, [eleRef.current]);
+
+  useEffect(()=>{
+    shortcutsRef.current = shortcuts;
+  }, [shortcuts]);
+}
diff --git a/web/pgadmin/static/js/custom_prop_types.js b/web/pgadmin/static/js/custom_prop_types.js
index 7ec2cda8c..6ba21a6d3 100644
--- a/web/pgadmin/static/js/custom_prop_types.js
+++ b/web/pgadmin/static/js/custom_prop_types.js
@@ -21,13 +21,23 @@ const CustomPropTypes = {
 
   children: PropTypes.oneOfType([
     PropTypes.arrayOf(PropTypes.node),
-    PropTypes.node
+    PropTypes.node,
   ]),
 
   className: PropTypes.oneOfType([
     PropTypes.string,
     PropTypes.object,
-  ])
+    PropTypes.array,
+  ]),
+
+  shortcut: PropTypes.shape({
+    alt: PropTypes.bool,
+    control: PropTypes.bool,
+    shift: PropTypes.bool,
+    key: PropTypes.shape({
+      char: PropTypes.string,
+    }),
+  }),
 };
 
 export default CustomPropTypes;
diff --git a/web/pgadmin/static/js/helpers/EventBus.js b/web/pgadmin/static/js/helpers/EventBus.js
new file mode 100644
index 000000000..a9d077820
--- /dev/null
+++ b/web/pgadmin/static/js/helpers/EventBus.js
@@ -0,0 +1,44 @@
+import React from 'react';
+import _ from 'lodash';
+
+export default class EventBus {
+  constructor() {
+    this._eventListeners = [];
+  }
+
+  registerListener(event, callback) {
+    this._eventListeners = this._eventListeners || [];
+    this._eventListeners.push({
+      event: event,
+      callback: callback,
+    });
+  }
+
+  deregisterListener(event, callback) {
+    if(callback) {
+      this._eventListeners = this._eventListeners.filter((e)=>{
+        if(e.event === event) {
+          return e.callback.toString()!=callback.toString();
+        }
+        return e.event!=event && e.callback.toString()!=callback.toString();
+      });
+    } else {
+      this._eventListeners = this._eventListeners.filter((e)=>e.event!=event);
+    }
+  }
+
+  fireEvent(event, ...args) {
+    Promise.resolve(0).then(()=>{
+      let allListeners = _.filter(this._eventListeners, (e)=>e.event==event);
+      if(allListeners) {
+        for(const listener of allListeners) {
+          Promise.resolve(0).then(()=>{
+            listener.callback(...args);
+          });
+        }
+      }
+    });
+  }
+}
+
+export const EventBusContext = React.createContext(new EventBus());
diff --git a/web/pgadmin/static/js/helpers/Layout.jsx b/web/pgadmin/static/js/helpers/Layout.jsx
new file mode 100644
index 000000000..5e3cbe9b0
--- /dev/null
+++ b/web/pgadmin/static/js/helpers/Layout.jsx
@@ -0,0 +1,179 @@
+import React from 'react';
+import DockLayout from 'rc-dock';
+import { makeStyles } from '@material-ui/styles';
+import PropTypes from 'prop-types';
+import CustomPropTypes from '../custom_prop_types';
+
+
+const useStyles = makeStyles((theme)=>({
+  docklayout: {
+    height: '100%',
+    '& .dock-tab-active': {
+      color: theme.otherVars.activeColor,
+      '&::hover': {
+        color: theme.otherVars.activeColor,
+      }
+    },
+    '& .dock-ink-bar': {
+      height: '3px',
+      backgroundColor: theme.otherVars.activeBorder,
+      color: theme.otherVars.activeColor,
+      '&.dock-ink-bar-animated': {
+        transition: 'none !important',
+      }
+    },
+    '& .dock-bar': {
+      paddingLeft: 0,
+      backgroundColor: theme.palette.background.default,
+      ...theme.mixins.panelBorder.bottom,
+    },
+    '& .dock-panel': {
+      border: 'none',
+      '&.dock-style-dialogs': {
+        '&.dock-panel.dragging': {
+          opacity: 1,
+        },
+        '& .dock-ink-bar': {
+          height: '0px',
+        },
+        '& .dock-panel-drag-size-b-r': {
+          zIndex: 1020,
+        },
+        '& .dock-tab-active': {
+          color: theme.palette.text.primary,
+          fontWeight: 'bold',
+          '&::hover': {
+            color: theme.palette.text.primary,
+          }
+        },
+      }
+    },
+    '& .dock-tab': {
+      minWidth: 'unset',
+      borderBottom: 'none',
+      marginRight: 0,
+      background: 'unset',
+      fontWeight: 'unset',
+      '&::hover': {
+        color: 'unset',
+      }
+    },
+    '& .dock-vbox, & .dock-hbox .dock-vbox': {
+      '& .dock-divider': {
+        flexBasis: '1px',
+        transform: 'scaleY(8)',
+        '&::before': {
+          backgroundColor: theme.otherVars.borderColor,
+          display: 'block',
+          content: '""',
+          width: '100%',
+          transform: 'scaleY(0.125)',
+          height: '1px',
+        }
+      }
+    },
+    '& .dock-hbox, & .dock-vbox .dock-hbox': {
+      '& .dock-divider': {
+        flexBasis: '1px',
+        transform: 'scaleX(8)',
+        '&::before': {
+          backgroundColor: theme.otherVars.borderColor,
+          display: 'block',
+          content: '""',
+          height: '100%',
+          transform: 'scaleX(0.125)',
+          width: '1px',
+        }
+      }
+    },
+    '& .dock-content-animated': {
+      transition: 'none',
+    },
+    '& .dock-fbox': {
+      zIndex: 1060,
+    }
+  }
+}));
+
+
+export class LayoutHelper {
+  static getPanel(attrs) {
+    return {
+      cached: true,
+      ...attrs,
+    };
+  }
+
+  static close(docker, panelId) {
+    docker.dockMove(docker.find(panelId), 'remove');
+  }
+
+  static focus(docker, panelId) {
+    docker.updateTab(panelId, null, true);
+  }
+
+  static openDialog(docker, panelData, width=500, height=300) {
+    let panel = docker.find(panelData.id);
+    if(panel) {
+      docker.dockMove(panel, null, 'front');
+    } else {
+      let {width: lw, height: lh} = docker.getLayoutSize();
+      lw = (lw - width)/2;
+      lh = (lh - height)/2;
+      docker.dockMove({
+        x: lw,
+        y: lh,
+        w: width,
+        h: height,
+        tabs: [LayoutHelper.getPanel({
+          ...panelData,
+          group: 'dialogs',
+          closable: true,
+        })],
+      }, null, 'float');
+    }
+  }
+
+  static openTab(docker, panelData, refTabId, direction, forceRerender=false) {
+    let panel = docker.find(panelData.id);
+    if(panel) {
+      if(forceRerender) {
+        docker.updateTab(panelData.id, LayoutHelper.getPanel(panelData), true);
+      } else {
+        LayoutHelper.focus(docker, panelData.id);
+      }
+    } else {
+      let tgtPanel = docker.find(refTabId);
+      docker.dockMove(LayoutHelper.getPanel(panelData), tgtPanel, direction);
+    }
+  }
+}
+
+export default function Layout({groups, layoutInstance, ...props}) {
+  const classes = useStyles();
+  const defaultGroups = React.useMemo(()=>({
+    'dialogs': {
+      disableDock: true,
+      tabLocked: true,
+      floatable: 'singleTab',
+    },
+    ...groups,
+  }), [groups]);
+  return (
+    <div className={classes.docklayout}>
+      <DockLayout
+        style={{
+          height: '100%',
+        }}
+        ref={layoutInstance}
+        groups={defaultGroups}
+        {...props}
+      />
+    </div>
+  );
+}
+
+Layout.propTypes = {
+  groups: PropTypes.object,
+  layoutInstance: CustomPropTypes.ref,
+};
diff --git a/web/pgadmin/static/js/helpers/Notifier.jsx b/web/pgadmin/static/js/helpers/Notifier.jsx
index b865d7cc6..68b2d8238 100644
--- a/web/pgadmin/static/js/helpers/Notifier.jsx
+++ b/web/pgadmin/static/js/helpers/Notifier.jsx
@@ -98,7 +98,7 @@ function AlertContent({text, confirm, okLabel=gettext('OK'), cancelLabel=gettext
   const classes = useAlertStyles();
   return (
     <Box display="flex" flexDirection="column" height="100%">
-      <Box flexGrow="1" p={2}>{HTMLReactParse(text)}</Box>
+      <Box flexGrow="1" p={2}>{typeof(text) == 'string' ? HTMLReactParse(text) : text}</Box>
       <Box className={classes.footer}>
         {confirm &&
           <DefaultButton startIcon={<CloseIcon />} onClick={onCancelClick} >{cancelLabel}</DefaultButton>
diff --git a/web/pgadmin/static/js/keyboard_shortcuts.js b/web/pgadmin/static/js/keyboard_shortcuts.js
index 74d482200..3a5afd7e1 100644
--- a/web/pgadmin/static/js/keyboard_shortcuts.js
+++ b/web/pgadmin/static/js/keyboard_shortcuts.js
@@ -21,7 +21,8 @@ const PERIOD_KEY = 190,
   K_KEY = 75;
 
 function isMac() {
-  return window.navigator.platform.search('Mac') != -1;
+  return window.navigator.userAgentData?.platform === 'macOS'
+   ||  window.navigator.platform.search('Mac') != -1;
 }
 
 function isKeyCtrlAlt(event) {
@@ -55,7 +56,7 @@ function isCtrlAltBoth(event) {
 /* Returns the key of shortcut */
 function shortcut_key(shortcut) {
   let key = '';
-  if(shortcut['key'] && shortcut['key']['char']) {
+  if(shortcut && shortcut['key'] && shortcut['key']['char']) {
     key = shortcut['key']['char'].toUpperCase();
   }
   return key;
diff --git a/web/pgadmin/static/js/tree/tree_init.tsx b/web/pgadmin/static/js/tree/tree_init.tsx
index 000258dff..f90690565 100644
--- a/web/pgadmin/static/js/tree/tree_init.tsx
+++ b/web/pgadmin/static/js/tree/tree_init.tsx
@@ -2,7 +2,7 @@
 //
 // pgAdmin 4 - PostgreSQL Tools
 //
-// Copyright (C) 2013 - 2021, The pgAdmin Development Team
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
 // This software is released under the PostgreSQL Licence
 //
 //////////////////////////////////////////////////////////////
diff --git a/web/pgadmin/static/js/tree/tree_nodes.ts b/web/pgadmin/static/js/tree/tree_nodes.ts
index 116ff5f79..6a903385d 100644
--- a/web/pgadmin/static/js/tree/tree_nodes.ts
+++ b/web/pgadmin/static/js/tree/tree_nodes.ts
@@ -2,7 +2,7 @@
 //
 // pgAdmin 4 - PostgreSQL Tools
 //
-// Copyright (C) 2013 - 2021, The pgAdmin Development Team
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
 // This software is released under the PostgreSQL Licence
 //
 //////////////////////////////////////////////////////////////
diff --git a/web/pgadmin/static/js/utils.js b/web/pgadmin/static/js/utils.js
index d4c93749e..9d6716533 100644
--- a/web/pgadmin/static/js/utils.js
+++ b/web/pgadmin/static/js/utils.js
@@ -442,3 +442,23 @@ export function registerDetachEvent(panel){
     });
   });
 }
+
+export function getBrowser() {
+  var ua=navigator.userAgent,tem,M=ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
+  if(/trident/i.test(M[1])) {
+    tem=/\brv[ :]+(\d+)/g.exec(ua) || [];
+    return {name:'IE', version:(tem[1]||'')};
+  }
+
+  if(M[1]==='Chrome') {
+    tem=ua.match(/\bOPR|Edge\/(\d+)/);
+    if(tem!=null) {return {name:tem[0], version:tem[1]};}
+  }
+
+  M=M[2]? [M[1], M[2]]: [navigator.appName, navigator.appVersion, '-?'];
+  if((tem=ua.match(/version\/(\d+)/i))!=null) {M.splice(1,1,tem[1]);}
+  return {
+    name: M[0],
+    version: M[1],
+  };
+}
